<template>
  <v-card>
    <v-card-title primary-title class="pb-0">
      <div>
        <div class="headline">Players</div>
        <!-- <div class="grey--text">A nice short caption.</div> -->
      </div>
    </v-card-title>
    <!-- Card Content -->
    <v-data-table :headers="headers" :items="items" :search="search" :loading="loading" :rows-per-page-items="[50, 100, 500]" hide-actions>
      <template slot="items" scope="props">
        <tr @click="user(props.item.id)">
          <td>{{props.item.fullName}}</td>
          <td>{{props.item.email}}</td>
          <td>{{props.item.contact}}</td>
        </tr>
      </template>
    </v-data-table>
    <!-- Actions -->
    <v-divider></v-divider>
    <v-card-actions>
      <v-dialog v-model="dialog" lazy>
        <v-btn primary flat slot="activator" class="ma-0">Open Dialog</v-btn>
        <v-card>
          <v-card-title>
            <div class="headline">Search</div>
          </v-card-title>
          <v-card-text>
            <v-text-field label="Type a name" v-model="searchedName" @keyup.native="searchName" />
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn class="green--text darken-1" flat="flat" @click.native="dialog = false">Disagree</v-btn>
            <v-btn class="green--text darken-1" flat="flat" @click.native="dialog = false">Agree</v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-card-actions>
  </v-card>
</template>

<script>
  export default {
    name: 'add-player',
    props: ['gameId'],
    data () {
      return {
        dialog: false,
        loading: true,
        search: null,
        searchedName: null,
        headers: [
          {text: 'Full Name', value: 'fullName', align: 'left'},
          {text: 'Position', value: 'teamPosition', align: 'left'}
        ],
        items: []
      }
    },
    methods: {
      searchName () {
        if (this.searchedName.length > 1) {
          // Search related string from database: https://stackoverflow.com/a/40633692
          let query = this.$database.ref('users')
            .orderByChild('fullName')
            .startAt(this.searchedName)
            .endAt(`${this.searchedName}\uf8ff`)
            .limitToLast(50)

          query.once('value').then(snapshot => {
            console.log(snapshot.val())
          })
        }
      }
    },
    created () {
      this.$database.ref(`games/${this.gameId}/players`).once('value').then(snapshot => {
        let players = snapshot.val()
        this.loading = false
        return players
      }).catch(error => console.log({error}))
    }
  }
</script>
